import logging
import os.path
import kraken.Constants
from kraken.tools.TextUi import inputString
from kraken.entrytypes.Entry import Entry, loadKraEntry, getEntryRdfFile
from kraken.entrytypes.MetaData import loadMetaData, updateCache
import kraken.query.FilterEditor as FilterEditor

# 
#   The description of the annotate entry stuff
# 
def description(system, runtime):
    return """
    Annotates (edits) one of the entries.
    """

# 
#   Annotate entry
# 
def execute(system, runtime):
    metadata = loadMetaData(system, runtime)
    md = FilterEditor.createSelectionFilter(system, metadata)
    for entry in md.entries:
        print "Annotating entry" + str(entry)
        val = annotateSingleEntry(system, entry.parentDirName,
                 entry.getProperty("directoryName"), metadata)
        if val:
            updateCache(system, runtime, metadata)
            # return
        
# 
#   Annotates a single entry from the directory of the kraken
# 
def annotateSingleEntry(system, directory, entryDir, metadata):
    dirname = os.path.join(directory, entryDir)
    if not os.path.isdir(dirname):
        return 0
    try:
        entry = loadKraEntry(system, directory, entryDir)
    except:
        logging.critical("The entry:" + entryDir + " could not be loaded!")
        return
    if (entry == None):
        return 0
    print entry
    entry.edit(metadata)
    entry.writeRDF(dirname)
    metadata.updateEntry(entry)
    return 1
