from rdflib.TripleStore import TripleStore
from rdflib.URIRef import URIRef
import re
from Ontology import Ontology

class DamlOil(Ontology):
  '''
  Represents a DAML+OIL ontology
  this is a VERY primitive implementation, just the beginning of a 
  beginning of a beginning. 
  '''
  RDF_TYPE = URIRef("http://www.w3.org/1999/02/22-rdf-syntax-ns#type")
  DAML_CLASS = URIRef("http://www.daml.org/2001/03/daml+oil#Class")
  DAML_PROPERTY = URIRef("http://www.daml.org/2001/03/daml+oil#Property")
  re_classname = re.compile("(.*)#(.*)")

  def __init__(self):
      self.store = None

  def load(self, damlfile):
      #damlfile = "kraken/entrytypes/bibtex/bibtex.o.daml"
      self.store = TripleStore()
      self.store.load(damlfile)

      
  def getClasses(self):
      # get all the classes
      classes = []    
      for s in self.store.subjects(predicate=self.RDF_TYPE, object=self.DAML_CLASS):
          mtch = self.re_classname.match(s)
          if mtch == None:
              print "Can got get the classname, although expected"
              continue
          classname = str(mtch.group(2))          
          classes.append(classname)
      return classes

  '''
     Returns the properties of the class named className
     For the time being, it returns all the properties in the ontology 
  '''
  def getProperties(self, className):
      properties = []
      for s in self.store.subjects(predicate=self.RDF_TYPE, object=self.DAML_PROPERTY):
          mtch = self.re_classname.match(s)
          if mtch == None:
              print "Can got get the propertyname, although expected"
              continue
          propertyname = str(mtch.group(2))
          properties.append(propertyname)
      return properties
      