from EntryBase import EntryBase 
from rdflib.URIRef import URIRef
from kraken.tools.UniqueIdGenerator import getUniqueId
from TypicalNamespaces import *
import kraken.Constants
import os.path
import os
import string
import logging
import kraken.data.descriptors
import traceback
import kraken.tools.TextUi as TextUi

# FIXME: this is needed because otherwise this is not executable. 
# But why is it working for the bibtex???
# import kraken.entrytypes.note.Note

class MetaDataDescriptor(EntryBase):
        
    def __init__(self):
        EntryBase.__init__(self)
        self.resourceURI = URIRef("descriptor://" + getUniqueId())
        self.registerProperty("name", "")
        self.registerProperty("description", "")
        self.registerProperty("entryClass", "")
        self.registerProperty("commandCreateEmpty","")
        self.registerProperty("nativeFileName", "")
        self.registerProperty("nativeFileMimeType", "")
        self.registerProperty("commandNativeEditor", "")        
        self.registerProperty("rdfFileName", "")
        self.registerProperty("commandRdfEditor", "")
        self.registerProperty("nativeIsPrimary", 1)    
        self.registerProperty("applicableToEntryTypes", []) 
        
    def getMapping(self, field):
        return NS_KRAKEN[field]
               
    def getRdfClass(self):
        return NS_KRAKEN["MetaDataDescriptor"]

    def getRdfFileName(self, entry):
        return os.path.join(entry.parentDirName, 
            entry.getProperty("directoryName"),
            kraken.Constants.DIRNAME_METADATA, 
            self.getProperty("rdfFileName"))
        
    def getNativeFileName(self, entry):
        return os.path.join(entry.parentDirName, 
            entry.getProperty("directoryName"),
            kraken.Constants.DIRNAME_METADATA, 
            self.getProperty("nativeFileName"))
            
    """
        Loads the secondary entry associated with it.
        It also adds it to the secondaries field.
        Returns None, if it is none. 
    """    
    def createSecondary(self, entry):
        print "createSecondary"
        entryClass = self.getProperty("entryClass")
        if entryClass == "":
            return None
        print "entryClass:" +  entryClass   
        try:
            entryModule = entryClass[0:string.rfind(entryClass,".")]
            #print "entryModule ", entryModule            
            __import__(entryModule, 
               globals(), 
               locals(), 
               [entryClass[string.rfind(entryClass,".")+1:]])
            secondary = eval(entryClass + "()")
            return secondary
        except:
            traceback.print_exc()
        return None

    
    def loadSecondary(self, entry):
       if not self.existsInEntry(entry):
           return
       try: 
          secondary = self.createSecondary(entry)
          if self.getProperty("nativeIsPrimary"):
             secondary.loadEntryFromNative(self.getNativeFileName(entry))
          else:
             secondary.readEntryFromRdf(self.getRdfFileName(entry))
          return secondary
       except:
           traceback.print_exc()
           return None
          
    def native2Rdf(self, entry):
       secondary = self.createSecondary(entry)
       secondary.loadEntryFromNative(self.getNativeFileName(entry))
       secondary.writeEntryToRdf(self.getRdfFileName(entry))

        
    """
       Checks for the existence of the entry
    """
    def existsInEntry(self, entry):     
        if self.getProperty("nativeIsPrimary"):
           nativeFileName = self.getNativeFileName(entry)
           return os.path.exists(nativeFileName)
        else:
           rdfFileName = self.getRdfFileName(entry)
           return os.path.exists(rdfFileName)
    
    def createForEntry(self, entry):
        self.executeStoredCommand("commandCreateEmpty", entry)
    
    """
    """
    def executeStoredCommand(self, commandname, entry):
        theCommand = self.getProperty(commandname)
        descriptor = self
        print theCommand
        if theCommand == "":
            logging.warning("Empty command " + commandname)
            return None
        value = eval(theCommand)
        return value
            
    def editEntry(self, entry, confirmCreation = 1):
        # print "Checking if this secondary previously existed?"
        if not self.existsInEntry(entry):
           if confirmCreation:
              val = TextUi.confirm("The secondary " + self.getProperty("name") +
                 " could not be found. Do you want to create it?")
              if not val:
                 return
           self.createForEntry(entry)
        else:
            print "The secondary found. Ok, lets proceed at editing"

        if self.getProperty("nativeIsPrimary"):
            print "Editing native"
            self.executeStoredCommand("commandNativeEditor", entry)
            self.native2Rdf(entry)
        else:
            print "Editing RDF"
            self.executeStoredCommand("commandRdfEditor", entry)
               
descriptors = {}

def getMetaDataDescriptors():
   if len(descriptors) != 0:
       return descriptors
   path = kraken.data.descriptors.__path__[0]
   files = os.listdir(path)
   
   for f in files:
        if f[-5:] != ".desc":
            continue
        filename = os.path.join(path, f)
        a = MetaDataDescriptor()
        a.readEntryFromRdf(filename)
        descriptors[a.getProperty("name")] = a

   return descriptors
   
   
