from rdflib.URIRef import URIRef
from rdflib.Namespace import Namespace
from kraken.entrytypes.EntryBase import EntryBase
from kraken.entrytypes.Secondary import Secondary
from kraken.tools.UniqueIdGenerator import getUniqueId
import time

# the self description of the class
namespaces = {}
# the namespaces  
namespaces["opinion"] = "http://www.cs.ucf.edu/~lboloni/Programming/KrakenWeb/Opinion/"
OPINION = Namespace(namespaces["opinion"])

class Opinion(EntryBase, Secondary):
  
  def __init__(self):
      EntryBase.__init__(self)
      self.filecontents_source = ""
      self.resourceURI = URIRef("opinion://" + getUniqueId())

      self.__class__.defaultMapping = OPINION      
      # initialize the fields, to set the types - this is needed for the time
      self.registerProperty("id", "")
      self.registerProperty("ranking", 0, prompt="Ranking [0-100]")
      self.registerProperty("lastVisited", time.localtime())
      self.registerProperty("lastModified", time.localtime())
      self.registerProperty("opinionOf","")
      self.registerProperty("trust", 100, prompt="Trust [-100, 100]") # perfect trust by default
      self.registerProperty("activity", 100, prompt="Activity [0-100]") # activity percentile, starts by being fully active
      
      
  #
  #  Command line based editing of an entry - mainly for annotation, etc
  #            
  def edit(self, metadata = None):
      print "Opinion"
      self.editField("ranking")
      self.editField("trust")
      self.editField("activity")
      
def createEmpty(entry, descriptor):
    op = Opinion()
    rdfFileName = descriptor.getRdfFileName(entry)
    op.writeEntryToRdf(rdfFileName)
    
def editOpinion(entry, descriptor):
    op = descriptor.loadSecondary(entry)
    op.edit()
    rdfFileName = descriptor.getRdfFileName(entry)
    op.writeEntryToRdf(rdfFileName) 
